package jartege ; 

import java.util.* ; 

/**
 * Classe des lments pouvant avoir un poids.
 */
abstract class ElementAPoids extends Element {
   
   // Poids de l'lment
   private double poids ; 

   // Constructeur
   ElementAPoids(String nom, double poids) {
      super(nom) ; 
      this.poids = poids ; 
   }

   // Constructeur
   ElementAPoids(String nom) {
      super(nom) ; 
      this.poids = 1 ; 
   }

   // Constructeur
   ElementAPoids() {
      super() ; 
      this.poids = 1 ; 
   }

   // Retourne le poids de l'lment
   public double getPoids() {
      return poids ; 
   }

   public void setPoids(double weight) {
      poids = weight ; 
   }

   // Choisit de faon alatoire un lment dans la liste d'lments
   // La probabilit de tirer un lmnt est proportionnelle  son poids. 
   static public ElementAPoids choisir(List list) {
      
      // Le liste des seuils 
      List seuils = new Vector() ; 

      double sommePoids = 0 ; 
      double sommeTotale = 0 ; 

      // Calcul du poids total du liste d'lments
      for (int i = 0 ; i < list.size() ; i++) {
         sommeTotale += ((ElementAPoids)(list.get(i))).getPoids() ; 
      }

      // Si la somme totale des poids est nulle, 
      // on ne peut choisir un lment.
      if (sommeTotale == 0) {
         return null ; 
      }

      // Calculs des seuils
      for (int i = 0 ; i < list.size() ; i++) {
         ElementAPoids elem = (ElementAPoids)(list.get(i)) ; 
         double poids = elem.getPoids() ; 
         sommePoids += poids ; 
         seuils.add(new Double(sommePoids / sommeTotale)) ; 
      }

      // Tirage d'une valeur alatoire comprise entre 0 et 1
      double val = RandomValue.floatValue(1) ; 

      // L'lmnt choisi
      ElementAPoids element = null ; 

      // Flottant correspondant au seuil de l'lment courant
      Double d ; 

      // Choix d'un lment suivant ce tirage
      for (int i = 0 ; i < list.size() && element == null ; i++) {
         d = (Double) seuils.get(i) ;  
         if (d.doubleValue() >= val) {
            element = (ElementAPoids)(list.get(i)) ; 
         }
      }
 
      return element ; 
   }
}
          
