package jartege ; 

import java.lang.reflect.* ; 
import java.util.* ; 
import java.io.* ; 

class OperationSet extends Operation {

   // Le champ correspondant  cette opration set
   Field theField ; 

   // Constructeur
   OperationSet(Field theField, Classe laClasse) {
      super(laClasse) ;
      this.theField = theField ;
      setNomComplet("set" + theField.getName()) ; 
      calculeVecteurMGP() ;
   }

   // Nom de base de la mthode gnrant les paramtres
   String nomBaseMGP() { 
      return "JRT_" + getNom() ; 
   }

   // Nom de la mthode gnrant le paramtre numro i
   String nomMGP(String nomBase) {
      return nomBase ; 
   }

   // Le type de retour de cette opration set
   Class typeRetour() {
      return Void.TYPE ; 
   }

   // Le type des paramtres de cette opration set
   Class[] typeParametres() {
      Class[] resultat = new Class[1] ; 
      resultat[0] = theField.getType() ; 
      return resultat ; 
   }

   // Vrai ssi l'attribut est un attribut de classe
   boolean estStatique() {
      return Modifier.isStatic(theField.getModifiers()) ;
   }

   /**
    * Evaluation d'un appel de cette operation set.
    */

   Object eval(Appel appel) throws 
         IllegalArgumentException, IllegalAccessException {
      theField.set(appel.getValeurParamImpl(), appel.getValeurTabParam()[0]) ;
      return null ; 
   }
      

   /**
    * Chaine de caractres correspondant  cet appel.
    */

   String toString(Appel appel) {
      String res = "" ;
      if (estStatique()) {
         res = res + laClasse.getNom() ;
      } else {
         res = res + appel.getParamImpl().toString() ; 
      }
      Expression param = appel.getTabParam()[0] ; 
      res = res + "." + theField.getName() + " = " + param.toString() ;
      return res ;
   }


   public String toString() {
      String res ; 
      res = typeRetour().getName() + " <set>" + theField.getName() + 
         "(" + typeParametres()[0].getName() + ")" ; 

      return res ; 
   }
}


