
package jartege ; 

import java.util.* ; 

/**
 * Class of sums.
 * A sum is a size specification which corresponds to the sum
 * of sizes of the object components.
 */

class Sum extends Size {

   // Liste des classes qui composent un objet construit
   List theClasses ; 

   // Coefficient constant dans le calcul de la somme
   int cstCoef ; 

   // The constructor associated with this sum
   Constructeur leConstructeur ; 

   /**
    * Constructeur.
    */
   Sum(int cstCoef, Constructeur leConstructeur) {
      Trace.afficher(2, "Sum(" + cstCoef + ", " + 
         leConstructeur.getNomComplet() + ") ->") ; 
      Classe classe = leConstructeur.laClasse ; 
      Dictionnaire dict = classe.leDictionnaire ; 
      this.cstCoef = cstCoef ; 
      this.leConstructeur = leConstructeur ; 
      theClasses = new Vector() ; 
      Class[] typeParametres = leConstructeur.typeParametres() ; 
      for (int i = 0 ; i < typeParametres.length ; i++) {
         Classe classeCour = dict.getClasse(typeParametres[i]) ;
         if (!classeCour.estPrimitif()) { 
            Trace.afficher(2, "Classe " + classeCour.getNomComplet() + 
               " ajoutee") ; 
            theClasses.add(dict.getClasse(typeParametres[i])) ; 
         }
      }
      Trace.afficher(2, "Sum(" + cstCoef + ", " + 
         leConstructeur.getNomComplet() + ") <-") ; 
   }

   /**
    * Removes the specified class of the list of constructors 
    * associated with this sum.
    */
   public void remove(String className) {
      Classe laClasse = leConstructeur.laClasse ; 
      Dictionnaire dict = laClasse.leDictionnaire ; 
      Classe c = dict.getClasse(className) ;
      theClasses.remove(c) ; 
   }

   int calcNumber(int i) {
      return 0 ; 
   }
}

